<!-- render errors -->
<ng-container *ngFor="let code of errorCodes">
  <!-- field error -->
  <app-field-error *ngIf="hasError(code)">
    {{ errors[code] }}
  </app-field-error>
</ng-container>

<!-- field -->
<div [class.error]="invalid" [class.focus]="focused" [class.has-value]="control.value" class="app-materialized-field">
  <!-- question icon -->
  <div class="app-icon">
    {{ character }}
  </div>

  <!-- input area -->
  <div class="app-input-area">
    <!-- label -->
    <div class="app-label">
      {{ label }}
    </div>

    <!-- input -->
    <input #input (blur)="blur()" (focus)="focus()" [formControl]="control" class="app-input" spellcheck="false" />
  </div>
</div>
